﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

using System.IO;
using EPiServer.Common;
//using Microsoft.VisualStudio.TestTools.UnitTesting;
//using Microsoft.VisualStudio.TestTools.UnitTesting.Web;
using System.Web.Configuration;

using EPiServer.Common.Sorting;
using EPiServer.Community.Blog;

namespace InitializeCommunityConsole
{
    class Program
    {
        static void Main(string[] args)
        {
            // Initialize Community
            Initialize();

            // Write something cool
            Blog blog = BlogHandler.Instance.GetBlog(1);
            Console.WriteLine(blog.Author.Name);
        }

        private static void Initialize()
        {
            // Need to initialize SiteMappingConfiguration and set the SiteId so that there is a siteId set even though there is no web context in the commandline context.
            new EPiServer.Framework.Initialization.SiteMappingConfiguration().Initialize(null);
            EPiServer.Framework.Initialization.SiteMappingConfiguration.Instance.SiteId = "MyRelateSite";


            EPiServer.Data.Configuration.EPiServerDataStoreSection.ConfigurationInstance = GetConfigurationFromFile();
            new EPiServer.Data.DataInitialization().Initialize(null);
            EPiServer.Search.Configuration.SearchSection.ConfigurationInstance = GetConfigurationFromFile();
            new EPiServer.Search.SearchInitialization().Initialize(null);

            EPiServer.Common.Configuration.EPiServerCommonSection.ConfigurationInstance = GetConfigurationFromFile();
            EPiServer.Community.Configuration.EPiServerCommunitySection.ConfigurationInstance = GetConfigurationFromFile();

            EPiServer.Common.Settings.LoadSettings();
        }

        private static System.Configuration.Configuration GetConfigurationFromFile()
        {
            if (System.Web.Hosting.HostingEnvironment.IsHosted)
            {
                return WebConfigurationManager.OpenWebConfiguration("~/");
            }
            else
            {
                WebConfigurationFileMap cfm = new WebConfigurationFileMap();
                cfm.VirtualDirectories.Add("/", new VirtualDirectoryMapping(Environment.CurrentDirectory, true));
                return WebConfigurationManager.OpenMappedWebConfiguration(cfm, "/");
            }
        }

    }
}
